
use strict;
use ExtUtils::MakeMaker;
#use Config qw(%Config);

my @programs_to_install = qw(gscmxx);
my $scmxxerror;

$| = 1;

=comment
print "\nChecking for SCMxx................ ";
eval {
	require SCMxxX;
};
if ($@) {
	$scmxxerror = 1;
	print "failed\n";
print <<EOT;
Trying to build SCMxx first.
EOT
	eval {
		my $cmd = "cd SCMxx; perl Makefile.PL " . join(" ", @ARGV);
		my $sys = system($cmd);
		if ($sys) {
			print "Could not build SCMxx Module\n\n";
			exit();
		}
	};
	if ($@) {
		print $@;
		exit();
	}
} else {
	print "ok\n";
}
=cut

# clean commandline arguments
my $i = 0;
foreach (@ARGV) {
	my ($k, $v) = split /=/, $_, 2;
	unless (exists $ExtUtils::MakeMaker::Recognized_Att_Keys{$k}) {
		splice(@ARGV, $i, 1);
	} else {
		$i++;
	}
}


my $missing_modules = 0;
print "Checking for Gtk-Perl.............";
eval {
	require Gtk;
};
if ($@) {
	print " failed\n";
	$missing_modules++;
	print <<EOT;
The Gtk-Perl modules must be installed. A gtk program without Gtk
is not really meaningfully.
You can get it from CPAN or http://www.gtkperl.org/

EOT
	sleep(2);
} else {
	print " ok\n";
}

print "Checking for Image::Size..........";
eval {
	require Image::Size;
};
if ($@) {
	print " failed\n";
	$missing_modules++;
	print <<EOT;
The Image::Size module is needed to display sizes of
bitmaps.
You can get it from CPAN or http://www.gtkperl.org/

EOT
	sleep(2);
} else {
	print " ok\n";
}


print "Checking for convert .............";
my $convert = `which convert 2>/dev/null` || '';
chomp $convert;
if ($convert && -e $convert && -x $convert) {
	print " ok\n";
} else {
	print " failed\n";
	print <<EOT;
To use the 'bitmap' functions (get from phone and save on phone)
you need to install 'convert' from the Image Magick package.
You can get it from http://www.imagemagick.org/

EOT
	sleep(2);
}
=comment
print "\nChecking for SCMxx ...............";
eval {
	require SCMxx;
};
if ($@) {
	print " failed\n";
	$missing_modules++;
	print <<EOT;
$@
The SCMxx modules must be installed. 

EOT
	sleep(2);
} else {
	print " ok\n";
}
=cut

# TODO breaks Makefile.PL on perl 5.6.1
#&rewritegscmxx;

#sleep(1);

# See lib/ExtUtils/MakeMaker.pm for details of how to influence
# the contents of the Makefile that is written.
WriteMakefile(
	'NAME'			=> 'gscmxx',
	'VERSION_FROM'	=> 'bin/gscmxx', # finds $VERSION
	'EXE_FILES'		=> [ map "bin/$_", @programs_to_install ],
	'dist'			=> { COMPRESS=>'gzip',SUFFIX=>'gz' },
	'PREREQ_PM'		=> { 'Gtk'	=> "0.7008" },
);

	#'PL_FILES'		=> {'bin/gscmxx.PL' => 'bin/gscmxx $(PREFIX) $(INSTALLSITELIB)' },

=comment
sub rewritegscmxx {

	my $file = 'bin/gscmxx';

#	rename($file, "$file.tmp");

	require Config;
	my %config;
	$config{startperl} = $Config::Config{'startperl'};

	my %args;
	foreach (@ARGV) {
		my ($k, $v) = split("=",$_, 2);
		$config{$k} = $v;
	}

#	print "STARTPERL: $Config::Config{'startperl'}\n";
#	print "INSTALLSITELIB: $Config::Config{'installsitelib'}\n";
#	print "PREFIX: $Config::Config{'prefix'}\n";


#open (TMP, ">/tmp/config"); 
#print TMP "Config: $_ => $Config::Config{$_}\n" foreach keys %Config::Config;
#print TMP "\n\n" . "-" x 50 . "\n\n";
#print TMP join("\n", @ARGV);
#print TMP "\n\n" . "-" x 50 . "\n\n";
#print TMP "ENV: $_ => $ENV{$_}\n" foreach keys %ENV;
#close(TMP);

	undef $/;
	open (FILE, "$file") || die "Can't open $file $!";
	my $script = <FILE>;
	close (FILE);

	$script =~ s/^#\!\/usr\/bin\/perl/$config{startperl}/;
	if ($config{PREFIX}) {
		
		($config{extralibs} = $Config::Config{'installsitelib'}) =~ s/^$Config::Config{'prefix'}/$config{PREFIX}/;
		$script =~ s/### special library path/### special library path\nuse lib "$config{extralibs}";/;
		$script =~ s/PREFIX/$config{PREFIX}/;
	}

	if (!(open(FILE, ">$file"))  ||
		!(print FILE $script)  ||
		!(close(FILE))) {
		die "Error while writing $file\n";
	}
	chmod(0755, $file);

}
=cut

package MY;

# install pixmaps and locale files

sub postamble {
	my $postamble = <<'END';
pixmaps ::
	$(MKPATH) $(PREFIX)/share/pixmaps/gscmxx
	@$(MOD_INSTALL) ./pixmaps/ $(PREFIX)/share/pixmaps/gscmxx/

i18n ::
	$(MKPATH) $(PREFIX)/share/gscmxx/i18n
	@$(MOD_INSTALL) ./share/i18n/ $(PREFIX)/share/gscmxx/i18n/

END
	return $postamble;
}

sub install {
	my $self = shift;
	my $string = $self->MM::install;
	my $add = 'pixmaps i18n';
	$string =~ s/(pure_install\s+)(.*)/$1 $add $2/;
	return $string;
}

=comment
# Determine things that should *not* be installed
sub libscan
{
    my($self, $path) = @_;
    return '' if $path =~ m/.(pl|dtd|sgml)$/;
    return '' if $path =~ m/^\./;
    return '' if $path =~ m:\bCVS/:;
    return '' if $path =~ m/^CVS$/;
    return '' if $path =~ m/~$/;
    $path;
}
=cut
