# most stuff ist borrowed from Glade-Perl .spec file
%define name gscmxx
%define version 0.4.1
%define release 1
%define prefix  /usr
%define filelst %{name}-%{ver}-files
%define arch noarch


%define subrel %( if [ -f "/etc/mandrake-release" ]; then echo "mdk"; else un=`uname -a | grep -i " ppc "`; if [ "$un" != "" ]; then echo "ppc"; else echo "rh"; fi; fi;)


Summary: Graphical Linux/Unix frontend for Siemens mobile phones
Name: %{name}
Version: %{version}
Release: %{release}%{subrel}
License: GNU GPL
Packager: Koppi <koppi@weirdoz.net>
Group: Applications/Communications
Source: http://prdownloads.sourceforge.net/gscmxx/%{name}-%{version}.tar.gz
URL: http://gscmxx.sourceforge.net
BuildArch: %{arch}
BuildRoot: /var/tmp/%{name}-%{version}-root
Requires: scmxx ImageMagick

%if %{subrel} == "mdk"
Requires: perl-GTK
%else
Requires: Gtk-Perl
%endif

%description
gscmxx is graphical frontend for Siemens mobile phones. It
allows you to edit your contacts book, send/read SMS's from/in
computer and more other features.

%prep

%setup -q

%build
if [ $(perl -e 'print index($INC[0],"%{prefix}/lib/perl");') -eq 0 ];then
    # package is to be installed in perl root
    inst_method="makemaker-root"
    CFLAGS=$RPM_OPT_FLAGS perl Makefile.PL PREFIX=%{prefix}
else
    # package must go somewhere else (eg. /opt), so leave off the perl
    # versioning to ease integration with automatic profile generation scripts
    # if this is really a perl-version dependant package you should not omiss
    # the version info...
    inst_method="makemaker-site"
    CFLAGS=$RPM_OPT_FLAGS perl Makefile.PL PREFIX=%{prefix} LIB=%{prefix}/lib/perl5
fi

echo $inst_method > inst_method

make

%install

rm -rf ${RPM_BUILD_ROOT}

MMVERSION=$(perl -e 'use ExtUtils::MakeMaker; print int($ExtUtils::MakeMaker::VERSION * 100)');

echo "MakeMake Version: $MMVERSION"

if [ $MMVERSION -lt 600 ]; then 
	PATHES=""
else
	PATHES="SITEPREFIX=$RPM_BUILD_ROOT%{prefix} \
		VENDORPREFIX=$RPM_BUILD_ROOT%{prefix} \
		INSTALLDIRS=site \
		INSTALLPRIVLIB=$RPM_BUILD_ROOT%{prefix}/lib/perl5/5.6.1 \
		INSTALLARCHLIB=$RPM_BUILD_ROOT%{prefix}/lib/perl5/5.6.1/i386-linux \
		INSTALLSITELIB=$RPM_BUILD_ROOT%{prefix}/lib/perl5/site_perl/5.6.1 \
		INSTALLSITEARCH=$RPM_BUILD_ROOT%{prefix}/lib/perl5/site_perl/5.6.1/i386-linux \
		INSTALLVENDORLIB=$RPM_BUILD_ROOT%{prefix}/lib/perl5/vendor_perl/5.6.1 \
		INSTALLVENDORARCH=$RPM_BUILD_ROOT%{prefix}/lib/perl5/vendor_perl/5.6.1/i386-linux \
		INSTALLBIN=$RPM_BUILD_ROOT%{prefix}/bin \
		INSTALLSCRIPT=$RPM_BUILD_ROOT%{prefix}/bin \
		INSTALLSITEBIN=$RPM_BUILD_ROOT%{prefix}/bin \
		INSTALLMAN1DIR=$RPM_BUILD_ROOT%{prefix}/share/man/man1 \
		INSTALLSITEMAN1DIR=$RPM_BUILD_ROOT%{prefix}/share/man/man1 \
		INSTALLMAN3DIR=$RPM_BUILD_ROOT%{prefix}/share/man/man3 \
		INSTALLSITEMAN3DIR=$RPM_BUILD_ROOT%{prefix}/share/man/man3 "
fi

# use all DIRS for MakeMaker 6 generated Makefiles
if [ "$(cat inst_method)" = "makemaker-root" ];then
   make UNINST=1 \
		PREFIX=$RPM_BUILD_ROOT%{prefix} \
		$PATHES \
 install

elif [ "$(cat inst_method)" = "makemaker-site" ];then
   make UNINST=1 
		PREFIX=$RPM_BUILD_ROOT%{prefix} \
		LIB=$RPM_BUILD_ROOT%{prefix}/lib/perl5 \
		$PATHES \
	install

fi

# Remove some unwanted files
find $RPM_BUILD_ROOT -name .packlist -exec rm -f {} \;
find $RPM_BUILD_ROOT -name perllocal.pod -exec rm -f {} \;
  

%__os_install_post
find $RPM_BUILD_ROOT -type f -print|sed -e "s@^$RPM_BUILD_ROOT@@g" > %{filelst}

%files -f %{filelst}
%defattr(-, root, root)
%doc Changes INSTALL README TODO doc/GPL.txt doc/Features.txt

%clean
rm -rf ${RPM_BUILD_ROOT}


%changelog

* Fri Nov  8 2002 Koppi <koppi@weirdoz.net>
- added new files (INSTALL, doc/Features.txt)

* Thu Aug 29 2002 Koppi <koppi@weirdoz.net>
- remove .packlist and perllocal.pod after install
- added check if its a mandrake distri
  (mandrake provides 'perl-GTK' not 'GTK-Perl')
- added check which MakeMaker is used to set correct pathes

* Tue Aug 27 2002 Koppi <koppi@weirdoz.net>
- first rpm release
